Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# QSignalMapper Class Reference

The QSignalMapper class bundles signals from identifiable senders. More...

    #include <QSignalMapper>

Inherits QObject.

- List of all members, including inherited members
- Obsolete members

### Writable Properties

- 1 writable property inherited from QObject

### Public Functions

- QSignalMapper ( QObject * parent = 0 )
- ~QSignalMapper ()
- QObject * mapping ( int id ) const
- QObject * mapping ( const QString & id ) const
- void removeMappings ( const QObject * sender )
- void setMapping ( const QObject * sender, int id )
- void setMapping ( const QObject * sender, const QString & id )

- 24 public functions inherited from QObject

### Public Slots

- void map ()

- 1 public slot inherited from QObject

### Signals

- void mapped ( int i )
- void mapped ( const QString & text )

- 1 signal inherited from QObject

### Static Public Members

- 4 static public members inherited from QObject

### Protected Functions

- 9 protected functions inherited from QObject

## Detailed Description

The QSignalMapper class bundles signals from identifiable senders.

This class collects a set of parameterless signals, and re-emits them with integer or string parameters corresponding to the object that sent the signal.

The class supports the mapping of particular strings or integers with particular objects using setMapping(). The objects' signals can then be connected to the map() slot which will emit the mapped() signal with the string or integer associated with the original signaling object. Mappings can be removed later using removeMappings().

Example:

Suppose we want to create a custom widget that contains a group of buttons (like a tool palette). One approach is to connect each button's clicked() signal to its own custom slot; but in this example we want to connect all the buttons to a single slot and parameterize the slot by the button that was clicked.

Here's the definition of a simple custom widget that has a single signal, clicked(), which is emitted with the caption of the button that was clicked:

        class ButtonWidget : public QWidget
        {
            Q_OBJECT

        public:
            ButtonWidget(QStringList captions, QWidget *parent=0, const char *name=0);

        signals:
            void clicked(const QString &chosen);

        private:
            QSignalMapper *signalMapper;
        };

The only function that we need to implement is the constructor:

        ButtonWidget::ButtonWidget(QStringList captions,
                                   QWidget *parent, const char *name)
            : QWidget(parent, name)
        {
            int row = 0;
            int col = 0;
            signalMapper = new QSignalMapper(this);
            QGridLayout *grid = new QGridLayout(this);
            QPushButton *button = 0;
            for (uint i = 0; i < captions.count(); i++) {
                button = new QPushButton(captions[i], this);
                connect(button, SIGNAL(clicked()), signalMapper, SLOT(map()));
                signalMapper->setMapping(button, captions[i]);
                grid->addWidget(button, row, col++);
                if (col == 3) {
                    ++row;
                    col = 0;
                }
            }
            connect(signalMapper, SIGNAL(mapped(const QString&)),
                    this, SIGNAL(clicked(const QString&)));
        }

A list of captions is passed to the constructor. A signal mapper is constructed and for each caption in the list a QPushButton is created. We connect each button's clicked() signal to the signal mapper's map() slot, and create a mapping in the signal mapper from each button to the text of its caption. Finally we connect the signal mapper's mapped() signal to the custom widget's clicked() signal. When the user clicks a button, the custom widget will emit a single clicked() signal whose argument is the text of the button the user clicked.

## Member Function Documentation

### QSignalMapper::QSignalMapper ( QObject * parent = 0 )

Constructs a QSignalMapper with parent parent.

### QSignalMapper::~QSignalMapper ()

Destroys the QSignalMapper.

### void QSignalMapper::map () `[slot]`

This slot emits signals based on which object sends signals to it.

### void QSignalMapper::mapped ( int i ) `[signal]`

This signal is emitted when map() is signaled from an object that has an integer mapping set. The object's mapped integer is passed in i.

See also setMapping().

### void QSignalMapper::mapped ( const QString & text ) `[signal]`

This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

This signal is emitted when map() is signaled from an object that has a string mapping set. The object's mapped string is passed in text.

See also setMapping().

### QObject * QSignalMapper::mapping ( int id ) const

Returns the sender QObject that is associated with the given id.

See also setMapping().

### QObject * QSignalMapper::mapping ( const QString & id ) const

This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

### void QSignalMapper::removeMappings ( const QObject * sender )

Removes all mappings for sender.

This is done automatically when mapped objects are destroyed.

### void QSignalMapper::setMapping ( const QObject * sender, int id )

Adds a mapping so that when map() is signaled from the given sender, the signal mapped(id) is emitted.

There may be at most one integer ID for each object.

See also mapping().

### void QSignalMapper::setMapping ( const QObject * sender, const QString & id )

This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

Adds a mapping so that when map() is signaled from the given sender, the signal mapper(id) is emitted.

There may be at most one string ID for each object, and it may not be empty.